<template>
  <div>
    <div class="flex flex-no-wrap bg-gray-200 text-white h-screen">
      <div
        class="w-64 absolute sm:relative bg-gray-800 shadow md:h-auto flex-col justify-between hidden sm:flex"
      >
        <Sidebar />
      </div>

      <div class="container mx-auto py-10 h-auto md:w-4/5 w-11/12 px-6">
        <div class="flex flex-col">
          <div class="-my-2 overflow-x-auto sm:-mx-6 lg:-mx-8">
            <div
              class="py-2 align-middle inline-block min-w-full sm:px-6 lg:px-8"
            >
              <div
                class="shadow overflow-hidden border-b border-gray-200 sm:rounded-lg"
              >
                <table class="min-w-full divide-y divide-gray-200">
                  <thead class="bg-gray-50">
                    <tr>
                      <th
                        scope="col"
                        class="px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider"
                      >
                        Nom
                      </th>
                      <th
                        scope="col"
                        class="px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider"
                      >
                        Utilisateurs
                      </th>
                      <th
                        scope="col"
                        class="px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider"
                      >
                        Status
                      </th>
                      <th
                        scope="col"
                        class="relative px-6 py-3 text-xs font-medium text-gray-500 uppercase"
                      >
                        <span>Actions</span>
                      </th>
                    </tr>
                  </thead>
                  <tbody class="bg-white divide-y divide-gray-200">
                    <tr v-for="(studio, key) in studios" :key="`${key}`">
                      <td class="px-6 py-4 whitespace-nowrap">
                        <div class="text-sm text-gray-900">
                          {{ studio.studio.name }}
                        </div>
                      </td>
                      <td class="px-6 py-4 whitespace-nowrap">
                        <div class="text-sm text-gray-900">
                          {{ studio.claimer.username }}
                        </div>
                      </td>
                      <td class="px-6 py-4 whitespace-nowrap">
                        <span
                          class="px-2 inline-flex text-xs leading-5 font-semibold rounded-full"
                          v-bind:class="
                            studio.studio.approved
                              ? 'bg-green-100 text-green-800'
                              : 'bg-red-100 text-red-800'
                          "
                          >{{ studio.studio.approved ? "Activé" : "En attente" }}</span
                        >
                      </td>
                      <td
                        class="px-6 py-4 whitespace-nowrap text-center text-sm font-medium"
                      >
                        <div
                          v-if="!studio.studio.approved"
                          class="flex gap-4 justify-center"
                        >
                          <a
                            @click="acceptStudio(studio.id, key)"
                            class="text-indigo-600 hover:text-indigo-900"
                            >Accepter</a
                          >
                          <a
                            @click="denyStudio(studio.id, key)"
                            class="text-indigo-600 hover:text-indigo-900"
                            >Refuser</a
                          >
                        </div>
                      </td>
                    </tr>
                  </tbody>
                </table>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import Sidebar from "./Sidebar"

export default {
  name: "Studio",
  components: {
    Sidebar
  },
  data() {
    return {
      studios: [],
      urlGetStudioClaims: `https://${window.location.hostname}:8443/studio_claims`
    }
  },
  inject: ["createAlert", "user"],
  beforeMount() {
    const headers = this.user
      ? {
          Accept: "application/json",
          "Content-Type": "application/json",
          Authorization: "Bearer " + this.user.token
        }
      : {
          Accept: "application/json",
          "Content-Type": "application/json"
        }

    fetch(this.urlGetStudioClaims, {
      headers,
      method: "GET"
    })
      .then((res) => {
        if (res.ok) {
          return res.json()
        } else {
          throw new Error("Something went wrong")
        }
      })
      .then((data) => {
        if (data) {
          this.studios = data
        } else {
          this.createAlert({
            color: "red",
            text: "Une erreur est survenue",
            icon: "times"
          })
        }
      })
      .catch(() => {
        this.createAlert({
          color: "red",
          text: "Une erreur est survenue",
          icon: "times"
        })
      })
  },
  methods: {
    acceptStudio: function(id, key) {
      const headers = this.user
        ? {
            Accept: "application/json",
            "Content-Type": "application/json",
            Authorization: "Bearer " + this.user.token
          }
        : {
            Accept: "application/json",
            "Content-Type": "application/json"
          }

      fetch(this.urlGetStudioClaims + "/" + id + "/accept", {
        headers,
        method: "GET"
      })
        .then((res) => {
          if (res.ok) {
            this.studios[key].studio.approved = true
          } else {
            throw new Error("Something went wrong")
          }
        })
        .catch(() => {
          this.createAlert({
            color: "red",
            text: "Une erreur est survenue",
            icon: "times"
          })
        })
    },
    denyStudio: function(id, key) {
      const headers = this.user
        ? {
            Accept: "application/json",
            "Content-Type": "application/json",
            Authorization: "Bearer " + this.user.token
          }
        : {
            Accept: "application/json",
            "Content-Type": "application/json"
          }

      fetch(this.urlGetStudioClaims + "/" + id, {
        headers,
        method: "DELETE"
      })
        .then((res) => {
          if (res.ok) {
            this.studios.splice(key, 1)
          } else {
            throw new Error("Something went wrong")
          }
        })
        .catch(() => {
          this.createAlert({
            color: "red",
            text: "Une erreur est survenue",
            icon: "times"
          })
        })
    }
  }
}
</script>

<style scoped>
.is-visible {
  display: block;
}
</style>
